@echo off
setlocal enabledelayedexpansion
pushd %~dp0

rem Set this to "1" if you've already installed tools\driver.pfx yourself
SET SKIPCERTINSTALL="0"

SET CERTUTIL=certutil

echo Administrative permissions required. Detecting permissions...

net session >nul 2>&1
if %errorLevel% == 0 (
    echo Success: Administrative permissions confirmed.
) else (
    echo Failure: Prebuild must be run as admin. Right-click, Run as Admin.
    pause .
    goto end
)

echo.
echo Setting Read-only attribute on required objects/libs...
attrib /S /D +r base\ntos\ex\mp\obj\i386\*.obj
attrib /S /D +r base\ntos\ex\mp\obj\ia64\*.obj
attrib /S /D +r base\ntos\ex\up\obj\i386\*.obj
attrib /S /D +r base\ntos\ex\up\obj\ia64\*.obj
attrib /S /D +r ds\security\services\ca\tools\certut\obj\*.lib
attrib /S /D +r inetcore\outlookexpress\external\obj\*.*
attrib /S /D +r inetcore\outlookexpress\external\objd\*.*
attrib /S /D +r inetcore\outlookexpress\external\objp\*.*

rem check OS version, delete pre-built stuff if the OS doesn't need it
rem (only Vista+ requires pre-built)
rem only 2000/XP/2003 handled here since older OS really shouldn't be building this code...

echo.
for /f "tokens=4-7 delims=[.] " %%i in ('ver') do (if %%i==Version (set v=%%j.%%k) else (set v=%%i.%%j))
echo Detected OS Version: %v%

if "%v%" == "5.2" goto delprebuilt
if "%v%" == "5.1" goto delprebuilt
if "%v%" == "5.0" goto delprebuilt

echo.
echo Setting attributes for pre-built ole16 objects (as your OS is unable to build them)
attrib /S /D +r com\ole32\olethunk\ole16\coll\obj\*.*
attrib /S /D +r com\ole32\olethunk\ole16\compobj\obj\*.*
attrib /S /D +r com\ole32\olethunk\ole16\daytona\obj\*.*
attrib /S /D +r com\ole32\olethunk\ole16\ole2\obj\*.*
attrib /S /D +r com\ole32\olethunk\ole16\storage\obj\*.*
attrib -r com\ole32\olethunk\ole16\compobj\obj\i386\compobj.*
attrib -r com\ole32\olethunk\ole16\storage\obj\i386\storage.*
attrib -r com\ole32\olethunk\ole16\ole2\obj\i386\ole2.*
attrib +r com\ole32\olethunk\ole16\storage\obj\i386\storage.obj
attrib +r com\ole32\olethunk\ole16\compobj\obj\i386\compobj.obj
attrib +r com\ole32\olethunk\ole16\ole2\obj\i386\ole2.obj

if exist com\ole32\olethunk\ole16\tools\link16_new.exe (
    del /F /Q com\ole32\olethunk\ole16\tools\link16_old.exe
    move com\ole32\olethunk\ole16\tools\link16.exe com\ole32\olethunk\ole16\tools\link16_old.exe
    move com\ole32\olethunk\ole16\tools\link16_new.exe com\ole32\olethunk\ole16\tools\link16.exe
)

if exist com\ole32\olethunk\ole16\tools\mapsym_new.exe (
    del /F /Q com\ole32\olethunk\ole16\tools\mapsym_old.exe
    move com\ole32\olethunk\ole16\tools\mapsym.exe com\ole32\olethunk\ole16\tools\mapsym_old.exe
    move com\ole32\olethunk\ole16\tools\mapsym_new.exe com\ole32\olethunk\ole16\tools\mapsym.exe
)

rem comlocal.cxx needs a tiny fix to work with newer link16 for some reason
if exist com\ole32\olethunk\ole16\compobj\comlocal.cxx.new (
    del /F /Q com\ole32\olethunk\ole16\compobj\comlocal.cxx
    move com\ole32\olethunk\ole16\compobj\comlocal.cxx.new com\ole32\olethunk\ole16\compobj\comlocal.cxx
)

goto importkey

:delprebuilt
rem use our own included certutil on XP/2003 as they don't seem to have it included with the OS...
set CERTUTIL=tools\certutil

echo.
echo Deleting unneeded pre-built ole16 files...
rmdir /Q /S com\ole32\olethunk\ole16\coll\obj
rmdir /Q /S com\ole32\olethunk\ole16\compobj\obj
rmdir /Q /S com\ole32\olethunk\ole16\daytona\obj
rmdir /Q /S com\ole32\olethunk\ole16\ole2\obj
rmdir /Q /S com\ole32\olethunk\ole16\storage\obj
del /F /Q com\ole32\olethunk\ole16\tools\link16_new.exe
del /F /Q com\ole32\olethunk\ole16\tools\mapsym_new.exe
del /F /Q com\ole32\olethunk\ole16\compobj\comlocal.cxx.new

:importkey

if "%SKIPCERTINSTALL%" == "1" goto done

echo.
echo Importing test-signing keys from driver.pfx...
echo (if prompted for anything, just hit enter or press OK)

tools\importpfx -f "tools\driver.pfx" -p "" -t USER -s "MY"

rem XP seems to have issues with importpfx, wtf?
if %errorLevel% == 0 goto done

echo.
echo ImportPFX.exe failed, trying import via certutil...

rem certutil can hang in certain configs (eg. Win7 SP1 unpatched)
echo. 
echo If this script hangs:
echo - Press CTRL+C and Y to exit this batch script
echo - Navigate to tools folder and import driver.pfx yourself by opening the file (double-click it)
echo (if prompted for anything, just hit enter or press OK)
echo - Edit prebuild.bat and set SKIPCERTINSTALL at the top to "1"
echo - Re-run prebuild.bat
echo. 

!CERTUTIL! /p "" /f /importpfx tools\driver.pfx

:done

echo.
echo Prebuild complete!
echo Now open command-prompt and run "tools\razzle free offline" inside it to init razzle
echo (make sure to run command-prompt as admin if your system uses UAC!)
pause .

:delend
popd
endlocal

del tools\certadm.dll
del tools\certutil.exe
del tools\importpfx.exe
del prebuild.bat & exit

:end
popd
endlocal